# 3次元の俯瞰図と等高線図を描く．
# x-y平面にメッシュを作成する．
x<-seq(-3,3,length=50)
y<-seq(-3,3,length=50)
# 関数を定義する．dnorm()は正規分布の確率密度の値を返す関数．
gauss3d<-function(x,y){dnorm(x)*dnorm(y)}
# 各メッシュ点のzの値を計算する．
z<-outer(x,y,gauss3d)
persp(x,y,z,theta=30,phi=30,expand=0.5,col="lightblue")
title("Perspective Plot")
dev.new()
contour(x,y,z)
title("Contour Plot")
