# 2次元の時系列データを作成する
t <- seq(0,1,length=200)
x <- cos(2*pi*t)+rnorm(200,sd=0.05)
y <- sin(2*pi*t)+rnorm(200,sd=0.05)
# グラフィックデバイスを分割する．
grph <- layout(matrix(c(2,2,1,3),2,2,byrow=TRUE), 
                 width=c(2,1), height=c(1,2), respect=TRUE)
layout.show(grph) # 分割の状態を確認
# 1の位置にリサジュー図を表示
par(mar=c(4,4,4,1)) # マージンの設定(下，左，上，右)
plot(x,y,col=4,type='p',main="Lissajous figure")
# 2の位置に時系列を表示
par(mar=c(4,4,4,2))
plot(t,x,col=2,pch=22,xlab="time",ylab="x,y",main="time series")
points(t,y,col=3,pch=23)
# 3の位置にyのヒストグラムを表示
yhist <- hist(y,plot=F)
par(mar=c(4,1,4,2))
barplot(yhist$counts,space=0,horiz=TRUE,main="histogram of y")
