# AdaBoostアルゴリズム
adaboost<-function(model,x,y,T=10,plot=FALSE){
  # 初期化
  n<-nrow(x)
  weight<-rep(1/n,n)
  tmp<-boosted()
  # 必要ならデータの分布を表示 (plotオプションで指定)
  if(plot==TRUE){plot(smpl(x,y));title("given examples")}
  # ブースティング (T回繰り返す)
  for(t in 1:T){
    # 弱学習器の学習
    learner<-learn(model,x,y,weight)
    # 重み付き誤差の計算
    z<-classify(learner,x)
    error<-((z-y)!=0)
    eps<-sum(as.numeric(error)*weight)
    # 信頼度の計算
    alpha<-log((1-eps)/eps)/2
    # 重みの更新と正規化
    weight<-weight*exp(-alpha*y*z)
    weight<-weight/sum(weight)
    # 必要ならデータの重みの変化を表示 (plotオプションで指定)
    if(plot==TRUE){
      plot(smpl(x,y,weight=weight))
      title(paste("evolution of weight (t=",t,")",sep=""))
    }
    # 弱学習器と信頼度をリストに追加
    tmp$learners[[t]]<-learner
    tmp$alpha[[t]]<-alpha
  }
  return(tmp)
}
