# 重み付け多数決による判別を計算するための関数
classify.boosted<-function(model,x){
  T<-length(model$alpha) # 弱学習器の個数
  n<-nrow(x) # データ数
  # データ毎に各弱学習器の判別結果を計算
  z<-matrix(unlist(lapply(model$learners,function(y){classify(y,x)})),n,T)
  # 重み付け多数決 (判別結果を信頼度で重み付けて正負を判定)
  return(sign(z%*%model$alpha))
}
