# ldfクラスを生成する関数
ldf<-function(p){ # p: 特徴量の次元
  model<-list(f=rep(1,p+1))
  class(model)<-'ldf'
  return(model)
}

# ldfクラスを学習する関数
learn.ldf<-function(model,x,y,weight=NULL){
  n<-nrow(x) # データ数
  if(is.null(weight)){
    weight<-rep(1/n,n)
  }
  xtil<-cbind(x,rep(1,n))
  tmp<-optim(rnorm(length(model$f)),
	function(z){return(sum(weight*(sign(xtil%*%z)!=y)))},method="SANN")
  # 最適化には"Nelder-Mead"などを用いることもできる
  model$f<-as.numeric(tmp$par)
  return(model)
}

# ldfクラスで判別を行う関数
classify.ldf<-function(model,x){
  n<-nrow(x)
  return(sign(cbind(x,rep(1,n))%*%model$f))
}
