# 重み付きデータを扱うためのクラス
smpl<-function(x,y,weight=NULL){
  n<-nrow(x)
  smpl<-list(x=x,y=y,weight=weight)
  class(smpl)<-'smpl'
  return(smpl)
}

# 表示で用いる色と記号の設定
d.col <- c("red","blue","red","blue")
d.ch <- c(1,21,6,24)
d.bg <- c("white","lightblue","white","lightblue")
d.persp <- "lightblue"

# 重み付きデータを表示するための関数
plot.smpl <- function(smpl) { # plot for weighted samples
  n<-nrow(smpl$x) # データ数
#  d<-ncol(smpl$x) #
  xrange<-c(floor(min(smpl$x[,1])),ceiling(max(smpl$x[,1])))
  yrange<-c(floor(min(smpl$x[,2])),ceiling(max(smpl$x[,2])))
  plot(0,0,xlim=xrange,ylim=yrange,type="n",xlab="x1",ylab="x2")
  if ( is.null(smpl$weight) ) {
    smpl$weight <- rep(1/n,n)
  }
  w <- sort(smpl$weight,index=TRUE,decreasing=TRUE)
  for ( i in w$ix ) {
    ifelse(smpl$y[i]>0,k<-1,k<-2)
    points(smpl$x[i,1],smpl$x[i,2],
      pch=d.ch[k],col=d.col[k],bg=d.bg[k],cex=n*smpl$weight[i])
  }
}
