# 1回のEMステップを計算する関数
emstep<-function(model,x){
  k<-length(model$models) # 混合数の取得
  x<-as.matrix(x)
  d<-ncol(x)
  n<-nrow(x)
  p<-cprob(model,x) # クラス条件付確率の計算
  for(i in 1:k) { # 各要素モデルの重み付き最尤推定量の計算
    model$models[[i]]<-mle(model$models[[i]],x,weight=drop(p[,i]))
  }
  model$prob<-apply(p,2,sum)/n # 混合パラメータの計算
  return(model)
}
