# gaussクラスの重み付き最尤推定 (正規分布の重み付き最尤推定)
mle.gauss<-function(model,x,weight=NULL){
  x<-as.matrix(x)
  d<-ncol(x)
  n<-nrow(x)
  if(is.null(weight)){ # 重みが与えられていない場合
    mu<-apply(x,2,sum)/n
    sigma<-crossprod(x)/n-mu%o%mu
  } else { # 重みが与えられている場合
    z<-sum(weight)
    mu<-apply(weight*x,2,sum)/z
    sigma<-crossprod(x,weight*x)/z-mu%o%mu
  }
  model$mu<-drop(mu)
  model$sigma<-sigma+diag(10^{-8},d) # 分散行列の縮退を避ける
  return(model)
}
