calc.exp.arg <- function(z,A,B){
  ## zとパラメーターA,Bを受け取り, モデル3の指数の中身を計算する関数
  ## 入力 (z[行列]: {+1,-1}からなるp次元の横ベクトルをn個並べた行列,
  ##      A[ベクトル]: p次元ベクトル, B[行列]:　p*p行列)
  ## 出力 (res[数列]: 長さnのベクトル)

  n <- nrow(z)
  res <- NULL
  N <- 5000
  r1 <- n %/% N
  r2 <- n %% N
  if(r1>=1){
    res <- c(apply(as.matrix(1:r1),1,function(x){
      z[c(((x-1)*N+1):(x*N)),] %*% as.matrix(A)+
        0.5*diag(z[c(((x-1)*N+1):(x*N)),] %*% B %*%
                 t(z[c(((x-1)*N+1):(x*N)),]))}))
  }
  if(r2 !=0){
    res <- c(res,z[c((r1*N+1):n),,drop=FALSE] %*% as.matrix(A)+
             0.5*diag(z[c((r1*N+1):n),,drop=FALSE] %*% B %*%
                      t(z[c((r1*N+1):n),,drop=FALSE])))
  }
  res
}
