make.info <- function(x,y){
  ## データの情報を構成する関数
  ## 入力 (x: 入力, y: ラベル)
  ## 出力 (INFO: 構成した情報)
  
  INFO <- list()
  INFO$name.x <- list()
  INFO$level.x <- list()

  for(i in 1:ncol(x)){ # 入力xの各列の情報
    if(is.vector(x[,i])){ # ベクトルの場合
      INFO$name.x[[i]] <- "vector"
      INFO$level.x[[i]] <- NULL
    }
    if(is.factor(x[,i])){ # 因子の場合
      INFO$name.x[[i]] <- "factor"
      INFO$level.x[[i]] <- levels(x[,i])
    }
  }
  # yの情報
  if(is.vector(y)){ # ベクトルの場合
    INFO$name.y <- "vector"
    INFO$level.y <- as.numeric(levels(factor(y)))
  }
  if(is.factor(y)){ # 因子の場合
    INFO$name.y <- "factor"
    INFO$level.y <- levels(y)
  }
  return(INFO)
}
