predict.binary <- function(res.bin,x){
  ## 関数learn.binaryで学習した結果res.binを用いて入力xの判別関数の値を予測する関数
  ## 入力 (res.bin: 関数learn.binary()の結果, x: 2値判別関数の値を得たい入力)
  ## 出力 (F[行列]: 判別関数の値, INFO: 入力，ラベルの情報, P.0: クラス事前確率)
  
  F <- matrix(0,nrow(x),length(res.bin$Fx))
  dat <- trans.data(x,y=NULL,res.bin$INFO,"all") # データの加工
  
  for(i in 1:length(res.bin$Fx)){ # 2値判別関数の値を計算
    F[,i] <- predict(res.bin$Fx[[i]],dat$x,type="decision")
  }
  return(list(F=F,INFO=res.bin$INFO,P.0=res.bin$P.0))
}
