predict.hamming <- function(res.bin,coder,y=NULL){
  ## ハミング復号を行う関数
  ## 入力 (res.bin[リスト]: learn.binary(),あるいはpredict.binary()の結果,
  ##      coder: 符号表, y: 多値のクラスラベル)
  ## 出力 (class: 予測されたクラスラベル, error: yが与えられた場合は誤り率を返す)
  
  # クラス予測
  class <- res.bin$INFO$level.y[max.col(sign(res.bin$F) %*% coder)]
  
  if(is.null(y)){ # ラベルが与えられなければクラス予測だけを返す
    res <- list(class=class)
  }
  else{ # ラベルが与えられればクラス予測と誤り率を返す
    res <- list(class=class,error=mean(y!=class,na.rm=TRUE))
  }
  return(res)
}
