predict.prob <- function(res.prob,res.binary){
  ## 関数learn.prob()で学習した結果res.probを用いて
  ## res.binaryに対応する2値ラベルの事後確率値を計算する関数
  ## 入力 (res.prob: learn.prob()の結果,
  ##      res.binary: learn.binary()あるいはpredict.binary()の結果)
  ## 出力 (PROB[行列]: 事後確率値, INFO: 入力，ラベルの情報,
  ##      n: 各判別問題で学習に用いた例題数)
  PROB <- matrix(0,nrow(res.binary$F),length(res.prob$p.model))
  for(i in 1:length(res.prob$p.model)){
    PROB[,i] <- predict(res.prob$p.model[[i]],
                        data.frame(F=res.binary$F[,i]),type="response")
  }
  return(list(PROB=PROB,INFO=res.binary$INFO,n=res.prob$n))
}
