library(adabag) # パッケージadabagの読み込み
library(mlbench) # パッケージmlbenchの読み込み
data(Vowel) # データセットvowelの読み込み
set.seed(1)
train.index <- sample(nrow(Vowel),600) # 600個を訓練データとして使用
T <- 50 # ステップを50に設定
MAXDEPTH <- c(1:10)*2
# 木の深さの最大値を変えながらadaboost.m1を学習
res <- list()
err.tra <- rep(1,length(MAXDEPTH))
err.gen <- rep(1,length(MAXDEPTH))
for(i in 1:length(MAXDEPTH)){
  res[[i]] <- adaboost.M1(Class~.,Vowel[train.index,],mfinal=T,
                          maxdepth=MAXDEPTH[i],coeflearn='Freund')
  err.tra[i] <- mean(res[[i]]$class !=Vowel[train.index,11])
  err.gen[i] <- mean(predict(res[[i]],Vowel[-train.index,])$class !=
                     Vowel[-train.index,11])
}

plot(MAXDEPTH,err.tra,xlab="maxdepth",ylab="Error rate",
     type="o",pch=21,ylim=range(err.tra,err.gen))
lines(MAXDEPTH,err.gen,col=2,pch=22,type="o")
legend(10,max(c(err.tra,err.gen)),c("Training error","Prediction error"),
       pch=c(21,22),col=c(1,2),lwd=rep(1,2),box.col=0)
