source("boost-source.adaboost.m2.r") # adaboost.m2関連の関数の読み込み
source("b2m-make.info.r") # データの情報を作成する関数，第15章参照
source("b2m-trans.data.r") # データの加工用の関数，第15章参照
library(adabag) # パッケージadabagの読み込み
library(mlbench) # パッケージmlbenchの読み込み
data(Glass) # データセットGlassの読み込み
P <- 10
set.seed(1)
train.index <- sample(nrow(Glass),150) # 150個を訓練データとして使用
# アダブースト.M2を100ステップまで訓練
res <- adaboost.m2(Glass[train.index,-P],Glass[train.index,P],100,r.b=0.5)
# アダブースト.M2を100ステップから1500ステップまで訓練
res <- adaboost.m2(Glass[train.index,-P],
                   Glass[train.index,P],1500,previous.res=res,r.b=0.5)
# テストデータのラベルの予測
res2 <- predict(res,Glass[-train.index,-P],Glass[-train.index,P])
# 訓練誤差のプロット
plot(res$error,xlab="Step",ylab="Error rate",type="l")
lines(res2$error,col=2,lty=2) # 予測誤差のプロット
legend(300,0.5,c("Training error","Prediction error"),
       col=c(1,2),lwd=rep(1,2),lty=rep(1,2),box.col=0)
dev.new()
# 各ステップの重み付き誤り率のプロット
plot(sapply(res$WL,function(z){z$E}),xlab="Step",
     ylab="Weighted error rate of weak hypothesis",type="l",pch=21)
