learn.adaboost.m2 <- function(x,y,T,wl,Y.num,previous.res,r.wl,r.b){

  t0 <- 1 
  p <- ncol(x)
  n <- nrow(x)
  class <- length(unique(y))
  error <- rep(0,T)
  loss <- rep(0,T)
  alpha <- rep(0,T)
  WL <- list()
  w <- matrix(1,n,class)
  w[cbind(c(1:n),y)] <- 0
  w <- w/sum(w)
  F <- matrix(0,n,class)

  if(!is.null(previous.res)){
    T.prev <- length(previous.res$alpha)
    if(T.prev >=T){
      return(previous.res)
    }
    else if(T.prev >length(previous.res$WL)){
      cat("Weighted error of weak learner is 0 in given previous result\n")
      return(previous.res)
    }
    else{
      t0 <- T.prev+1
      error <- previous.res$error
      loss <- previous.res$loss
      WL <- previous.res$WL
      alpha[1:T.prev] <- previous.res$alpha
      for(t in 1:T.prev){
        F <- F+alpha[t]*predict(WL[[t]],x)
      }
      w <- exp(F-F[cbind(c(1:n),y)])
      w[cbind(c(1:n),y)] <- 0
      w <- w/sum(w)  #Normalization of weight
    }
  }

  cat(c(0,"|__________|",100,"\n",sep=""))
  cat(" |")
  for(t in t0:T){
    WL[[t]] <- list()
    class(WL[[t]]) <- wl
    ## weak learning
    WL[[t]] <- learn.stump.m(WL[[t]],x,y,w,Y.num,r.wl,r.b)
    ## If error rate of stump is 0, then algorithm stops
    if(WL[[t]]$E==0){
      alpha[t] <- 0.5*log((1-min(w)/100)/(min(w)/100))
      F <- alpha[t]*predict(WL[[t]],x)
      error[t:T] <-  mean(sign(y != sign(F) ))
      loss[t:T] <- mean( exp(F-F[cbind(c(1:n),y)]) )
      cat(c("\n",paste("Error rate of weak learner is greater than 0.5 at step",t)))
      break
    }
    else{
      ## Calculation of alpha	
      alpha[t] <- 0.5*log((1-WL[[t]]$E)/WL[[t]]$E)
      ## Update of discriminant function
      F <- F+alpha[t]*predict(WL[[t]],x)
      ##  Update of weight
      w <- exp(F-F[cbind(c(1:n),y)])
      w[cbind(c(1:n),y)] <- 0
      w <- w/sum(w)  #Normalization of weight
      error[t] <-  mean(sign(y != max.col(F) ))
      loss[t] <- mean( exp(F-F[cbind(c(1:n),y)]) )
      if( ((t-t0+1)%% ((T-t0+1)/10))<1){
        cat("*")
      }     
    }
  }
  cat(c("|\n"))
  res <-  list(error=error,loss=loss,F=F,alpha=alpha,WL=WL)
  class(res) <- 'adaboost.m2'
  return(res)
}
