predict.adaboost.m2 <- function(res,x,y=NULL,T=length(res$WL)){
  ## アダブースト.M2の結果を用いてラベルを予測する関数
  ## 入力 (res: adaboost.m2の結果，x: 入力,y: ラベル,T: ステップ数)
  ## 出力 (class: 予測されたクラスラベル, error: 誤り率, F: 判別関数の値)
  
  F <- matrix(0,nrow(x),length(res$INFO$level.y))
  
  if(is.null(y)){
    dat <- trans.data(x,y=NULL,res$INFO,"all")
    
    for(t in 1:T){
      F <- F+res$alpha[t]*predict(res$WL[[t]],dat$x)
    }
    class <- res$INFO$level.y[max.col(F)]
    return(list(F=F,class=class))
  }
  else{
    error <- rep(0,T)
    dat <- trans.data(x,y,res$INFO,"all")
    for(t in 1:T){
      F <- F+res$alpha[t]*predict(res$WL[[t]],dat$x)
      error[t] <- mean(max.col(F)!=dat$y)
    }
    class <- res$INFO$level.y[max.col(F)]
    res <- list(F=F,class=class,error=error)
  }

  return(res)
}

