uboost <- function(x,y,T=100,wl="stump",Uloss="exp",na.action="remove",previous.res=NULL,eta=0.5){
  ## na.action = "remove": uboost is learned with dataset without NA. Default setting.
  ## na.action = "all"    : uboost is learned with all dataset. stump returns 0 for NA variable.

  INFO <- make.info(x,y)
  dat <- trans.data(x,y,INFO,na.action)
  INFO$na.index <- dat$na.index
  INFO$na.action <- na.action

  res <- learn.uboost(dat$x,dat$y,T,wl,Uloss=Uloss,previous.res=previous.res,eta=eta)

  if(na.action=="remove"){
    if(length(INFO$na.index)>0){
      F.all <- rep(0,length(y))
      dat <- trans.data(x[,,drop=FALSE],y,INFO,"all")
      F.all <- predict(res,dat$x,dat$y,T)$F
      res$F <- F.all
    }
  }

  res$INFO <- INFO
  res$class <- INFO$level.y[(sign(res$F)+3)/2]
  class(res) <- 'uboost'
  return(res)
}
