data(iris) # データセットirisの読み込み
# 7割の例題を訓練データとして用いる
train.index <- sample(nrow(iris),nrow(iris)*0.7) 
library(MASS) # パッケージMASSの読み込み
# フィッシャーの判別分析
res.lda <- lda(Species~.,iris,subset=train.index,method="moment")
# 1,2番目の固有ベクトルを使った時の訓練誤差
mean(predict(res.lda,iris[train.index,])$class != iris[train.index,5])
# 1,2番目の固有ベクトルを使った時の予測誤差
mean(predict(res.lda,iris[-train.index,])$class != iris[-train.index,5])
# 1番目の固有ベクトルを使った時の訓練誤差
mean(predict(res.lda,iris[train.index,],dimen=1)$class != iris[train.index,5])
# 1番目の固有ベクトルを使った時の予測誤差
mean(predict(res.lda,iris[-train.index,],dimen=1)$class != iris[-train.index,5])

# 事前分布を(1/6,2/6,3/6)に設定
res2.lda <- lda(Species~.,iris,subset=train.index,prior=c(1,2,3)/6)
# 1,2番目の固有ベクトルを使った時の訓練誤差
mean(predict(res2.lda,iris[train.index,])$class != iris[train.index,5])
# 1,2番目の固有ベクトルを使った時の予測誤差
mean(predict(res2.lda,iris[-train.index,])$class != iris[-train.index,5])

# 外れ値に対してロバストなt-分布を用いた推定
res3.lda <- lda(Species~.,iris,subset=train.index,method="t")
# 1,2番目の固有ベクトルを使った時の訓練誤差
mean(predict(res3.lda,iris[train.index,])$class != iris[train.index,5])
# 1,2番目の固有ベクトルを使った時の予測誤差
mean(predict(res3.lda,iris[-train.index,])$class != iris[-train.index,5])
# 第1，第２固有ベクトルで張られる空間に射影したデータの散布図
plot(res.lda,abbrev=TRUE,dimen=2,col=match(iris[train.index,5],levels(iris[,5])))
