source("b2m-config.r")
source("descr-lfda.r")

N <- 200
x <- matrix(rnorm(N*2),N,2)
x[,2] <- x[,2]*10
THETA <- pi/4
R <- matrix(c(cos(THETA),sin(THETA),-sin(THETA),cos(THETA)),2,2)

y <- rep(c(1,2),each=N/2)
X <- x
X[y==1,1][1:(N/4)] <- X[y==1,1][1:(N/4)] +5
X[y==1,1][(N/4):(N/2)] <- X[y==1,1][(N/4):(N/2)] -5
X[y==2,2] <- X[y==2,2] +0
X <- X %*% R
X <- cbind(X,matrix(runif(N*10),N,10),matrix(rnorm(N*10),N,10))
X <- t(t(X)-apply(X,2,mean))

MU1 <- apply(X[y==1,],2,mean)
MU2 <- apply(X[y==2,],2,mean)
MU <- apply(X,2,mean)
Ng <- table(y)
Vb <- Ng[1]*as.matrix(MU1-MU) %*% t(as.matrix(MU1-MU))+
  Ng[2]*as.matrix(MU2-MU) %*% t(as.matrix(MU2-MU))
Vw <- (t(X[y==1,])-MU1) %*% t(t(X[y==1,])-MU1)+
  (t(X[y==2,])-MU2) %*% t(t(X[y==2,])-MU2)
par(mfcol=c(1,3))
plot(X[,1:2],col=rep(c(1,2),each=N/2),xlab="x1",ylab="x2",
     pch=rep(c(21,22),each=N/2))
Y <- eigen(solve(Vw)%*% Vb)$vectors[,1]
SEQ <- seq(-30,30,length=100)
lines(SEQ,SEQ*Y[2]/Y[1],lty=2,lwd=4,col=3)

res.lfda0 <- lfda(X,y,lambda=0)
plot(res.lfda0$X[,1:2],col=y)
#res.lda <- lda(X,y)
#plot(res.lda,dimen=2)
res.lfda1 <- lfda(X,y,lambda=0.01)
plot(res.lfda1$X[,1:2],col=y)
