N <- 200
x <- matrix(rnorm(N*2),N,2)
x[,2] <- x[,2]*10
THETA <- pi/4
R <- matrix(c(cos(THETA),sin(THETA),-sin(THETA),cos(THETA)),2,2)
X <- x %*% R
y <- rep(c(1,2),each=N/2)
X[y==1,1] <- X[y==1,1] +5
X[y==2,1] <- X[y==2,1] -5
X <- t(t(X)-apply(X,2,mean))
plot(X,col=rep(c(1,2),each=N/2),xlab="x1",ylab="x2",
     pch=rep(c(21,22),each=N/2))
Y <- -20*princomp(X)$loadings
arrows(0,0,Y[1,1],Y[2,1],col=3,lwd=4)
legend(10,-5,c("PC 1"),col=3,lwd=4,box.col=1)

dev.new()
plot(X,col=rep(c(1,2),each=N/2),xlab="x1",ylab="x2",
     pch=rep(c(21,22),each=N/2))
points(mean(X[y==1,1]),mean(X[y==1,2]),col=1,pch=21,lwd=5,bg=1)
points(mean(X[y==2,1]),mean(X[y==2,2]),col=2,pch=22,lwd=5,bg=2)
SEQ <- seq(-30,30,length=100)
R <- (apply(X[y==1,],2,mean)-apply(X[y==2,],2,mean))
M0 <- (apply(X[y==1,],2,mean)+apply(X[y==2,],2,mean))/2
lines(SEQ,R[2]*(SEQ-M0[1])/R[1]+M0[2],lty=2,lwd=4,col=3)

dev.new()
MU1 <- apply(X[y==1,],2,mean)
MU2 <- apply(X[y==2,],2,mean)
MU <- apply(X,2,mean)
Ng <- table(y)
Vb <- Ng[1]*as.matrix(MU1-MU) %*% t(as.matrix(MU1-MU))+
  Ng[2]*as.matrix(MU2-MU) %*% t(as.matrix(MU2-MU))
Vw <- (t(X[y==1,])-MU1) %*% t(t(X[y==1,])-MU1)+
  (t(X[y==2,])-MU2) %*% t(t(X[y==2,])-MU2)
plot(X,col=rep(c(1,2),each=N/2),xlab="x1",ylab="x2",
     pch=rep(c(21,22),each=N/2))
Y <- eigen(solve(Vw)%*% Vb)$vectors[,1]
lines(SEQ,SEQ*Y[2]/Y[1],lty=2,lwd=4,col=3)
