library(mlbench)
data(Vowel) # データの読み込み
N <- 700 # 600個を訓練データとして使用
set.seed(1)
train.index <- sample(nrow(Vowel),N)
library(MASS)
res.lda <- lda(Class~.,Vowel,subset=train.index) # 線形判別析分
yhat0 <- predict(res.lda,Vowel)$class # ラベルの予測
mean(yhat0[train.index] != Vowel[train.index,11]) # 訓練誤差
mean(yhat0[-train.index] != Vowel[-train.index,11]) #　予測誤差
table(Vowel[,11],yhat0) # 判別結果の内訳 行が元のラベル，列は予測ラベル

res.qda <- qda(Class~.,Vowel,subset=train.index) # 2次判別分析
yhat <- predict(res.qda,Vowel)$class # ラベルの予測
mean(yhat[train.index] != Vowel[train.index,11]) # 訓練誤差
mean(yhat[-train.index] != Vowel[-train.index,11]) #　予測誤差
table(Vowel[,11],yhat) # 判別結果の内訳 行が元のラベル，列は予測ラベル

# 1,2,3番目の固有ベクトルで張られる空間にデータを射影した時の散布図
plot(res.lda,dimen=3,col=match(Vowel[train.index,11],levels(Vowel[,11])))
