library(klaR) # klaRパッケージの読み込み
library(mlbench) # mlbenchパッケージの読み込み
data(Vowel)
N <- 700 # 700個を訓練データとして使用
set.seed(1)
train.index <- sample(nrow(Vowel),N)
# 正則化判別分析．正則化パラメーターは訓練誤差最小基準で自動決定
(res.rda <- rda(Class~.,Vowel,subset=train.index))
yhat <- predict(res.rda,Vowel)$class
mean(yhat[train.index] != Vowel[train.index,11]) # 訓練誤差
mean(yhat[-train.index] != Vowel[-train.index,11]) # 予測誤差
