library(klaR) # klaRパッケージの読み込み
library(mlbench) # mlbenchパッケージの読み込み
data(Vowel)
N <- 700 # 700個を訓練データとして使用
set.seed(1)
train.index <- sample(nrow(Vowel),N)
M <- 10
err.tra <- rep(1,M)
err.gen <- rep(1,M)
param <- seq(0,1,length=M)
for(i in 1:M){
  res2.rda <- rda(Class~.,Vowel,subset=train.index,
                  lambda=param[i],gamma=0.5)
  err.tra[i] <- mean(predict(res2.rda,Vowel[train.index,])$class !=
                     Vowel[train.index,11])
  err.gen[i] <- mean(predict(res2.rda,Vowel[-train.index,])$class !=
                     Vowel[-train.index,11])
}
plot(param,err.tra,xlab="lambda",ylab="error rate",
     ylim=range(err.tra,err.gen),pch=21)
points(param,err.gen,col=2,pch=22)
