calc.fmeasure <- function(F,y){
  # 判別に用いる値Fとラベルyを受け取ってF値を計算する関数
  # 入力 (F[ベクトル]: 入力に対する判別関数の値（符号をとる前の値)，y: ラベル)
  # 出力 (fmeasure: F値, precision: 適合率, recall:　再現率)

  y <- match(y,levels(factor(y)))*2-3
  FP <- mean(F[y==-1]>=0)
  TP <- mean(F[y==1]>=0)
  Pre <- TP/(TP+FP)
  Rec <- TP
  
  fmeasure <- 2*TP/(1+TP+FP)
  return(list(fmeasure=fmeasure,precision=Pre,recall=Rec))
}
