source("eval-calc.fval.r")
library(klaR)
library(mlbench)
dat <- mlbench.circle(200)
M <- 20
fval <- rep(0,M)
pre <- rep(0,M)
rec <- rep(0,M)
err <- rep(0,M)
param <- seq(0,1,length=M)
for(i in 1:M){
  res <- rda(dat$x,dat$classes,lambda=param[i],gamma=0.5)
  err[i] <- mean(predict(res,dat$x)$class != dat$classes)
  res2 <- calc.fval(predict(res,dat$x)$posterior[,2]-0.5,dat$classes)
  fval[i] <- res2$fval
  pre[i] <- res2$pre
  rec[i] <- res2$rec
}
name <- "../Fig/eval-demo.calc.fval.err.eps"
postscript(name,height=6,width=6,paper="special",horizontal=FALSE)
plot(param,err,xlab="lambda",ylab="Error",type="o")
dev.off()
name <- "../Fig/eval-demo.calc.fval.eps"
postscript(name,height=6,width=6,paper="special",horizontal=FALSE)
plot(param,fval,xlab="lambda",ylab="F-value",type="o",ylim=range(c(fval,pre,rec)))
lines(param,pre,type="o",lty=2,col=2)
lines(param,rec,type="o",lty=3,col=3)
legend(0,0.7,c("F-value","Precision","Recall"),lty=rep(1:3),lwd=rep(1,3),col=c(1:3))
dev.off()



