library(mclust)
library(mlbench) # mlbench.corners
library("scatterplot3d")
# データの生成
dat <- mlbench.corners()
colnames(dat$x) <- c("x1","x2","x3")
# データの3次元表示
scatterplot3d(dat$x, color=as.numeric(dat$classes),
   pch=as.numeric(dat$classes)%%5+21)
title("3D Scatter Plot")
# 混合正規分布モデルの推定
(gmm <- Mclust(dat$x))
# 比較されたモデルのBICの表示
dev.new()
plot.mclustBIC(gmm$BIC)
# 推定モデルとラベルの2次元表示
dev.new()
randProj(dat$x,parameters=gmm$parameters,
         classification=dat$classes,what="classification",identify=TRUE)
# クラスタリング結果の表示
dev.new()
clPairs(dat$x,gmm$classification,symbols=as.character(1:8))

