library(mclust)
library(mlbench) # mlbench.smiley
# 学習データとテストデータの生成
train <- mlbench.smiley(n=300)
test  <- mlbench.smiley(n=200)
colnames(train$x) <- c("x1","x2") 
colnames(test$x) <- c("x1","x2")
# 各データの表示
plot(train,pch=as.numeric(train$classes)+20,
     main="Training Data")
dev.new()
plot(test,pch=as.numeric(test$classes)+20,bg=as.numeric(test$classes),
     main="Test Data")
# 学習データによる推定
(gmm <- Mclust(train$x))
# 学習結果を用いてテストデータをクラスタリング
testcl <- map(cdens(modelName=gmm$modelName,
                    data=test$x,parameters=gmm$parameters))
# クラスタリングの結果を表示
dev.new()
mclust2Dplot(test$x,parameters=gmm$parameters,classification=testcl)
title("Classification")
# 学習データのクラスタリング結果と真のクラスとの比較
table(true=train$classes,est=gmm$classification) 
# 混合モデルの要素番号と真のクラスとの対応関係を作成
(cltab <- apply(table(true=train$classes,
                     est=gmm$classification),2,which.max))
# テストデータのクラスタリング結果を対応関係を用いて変換
table(true=test$classes,est=cltab[testcl])
