library(mclust)
library(mlbench) # mlbench.smiley
# 実験データの生成
dat <- mlbench.smiley()
colnames(dat$x) <- c("x1","x2") # 各座標軸に名前を付ける
plot(dat,pch=as.numeric(dat$classes)+20) # データの2次元表示
# 混合正規分布モデルの推定 (要素モデルの数を4-10から自動選択)
(gmm <- Mclust(dat$x,G=4:10))
attributes(gmm) # Mclustクラスの内容を表示
gmm$modelName # 要素モデルの制約を表示
gmm$G # 推定された要素数
# gmm$parameters # 推定された平均と分散を表示
# クラスタリング結果の表示
dev.new()
mclust2Dplot(dat$x,parameters=gmm$parameters,z=gmm$z,what="classification")
title("Classification")
# クラスタリングの不確かさの表示 (等高線表示)
dev.new()
mclust2Dplot(dat$x,parameters=gmm$parameters,z=gmm$z,what="uncertainty")
title("Uncertainty Contour Plot")
# クラスタリングの不確かさの表示 (濃淡表示)
dev.new()
surfacePlot(dat$x,parameters=gmm$parameters,type="image",what="uncertainty")
title("Uncertainty Image Plot")
# 密度の表示 (等高線)
dev.new()
surfacePlot(dat$x,parameters=gmm$parameters,type="contour",what="density")
title("Density Contour Plot")
# 密度の表示 (俯瞰図)
dev.new()
surfacePlot(dat$x,parameters=gmm$parameters,type="persp",what="density")
title("Density 3D Plot")

