library(mlbench) # for Vowel
data(Vowel)
# 学習データの生成
n <- 30 # データ数
k <- 5
idx <- sample(1:(66*k),n) # k人の話者のデータからランダムに選択
x <- scale(Vowel[idx,2:10]) # 10の特徴量のうち量的なものを正規化
y <- factor(Vowel[idx,1]) # 対応する話者のラベル
# 階層的クラスタリングを行う
hc <- hclust(dist(x,method="manhattan"),method="ward")
# 樹形図をk個に分割してグループ番号を対応させたベクトルを取得する
(yest <- cutree(hc,k=k)) 
table(est=yest,true=y) # 対応表の作成
