library(mlbench) # for Vowel
data(Vowel)
# 学習データの生成
n <- 36 # データ数
num <- 3 # 話者の番号を指定
idx <- sample(which(Vowel[,1]==num),n) # 特定の話者のデータからランダムに選択
x <- scale(Vowel[idx,2:10]) # 10の特徴量のうち量的なものを正規化して用いる
y <- Vowel$Class[idx] # 対応するラベル
# 異なる距離(対象間，クラスタ間)の組み合わせで樹形図を表示する
hc1 <- hclust(dist(x))
plot(hc1,labels=y)
dev.new()
hc2 <- hclust(dist(x),method="ward")
plot(hc2,labels=y)
dev.new()
hc3 <- hclust(dist(x,method="manhattan"))
plot(hc3,labels=y)
dev.new()
hc4 <- hclust(dist(x,method="manhattan"),method="ward")
plot(hc4,labels=y)
