library(mlbench) # for Vowel
data(Vowel)
# 学習データの生成
n <- 100 # データ数
k <- 11 # 分割するクラス数
idx <- sample(1:nrow(Vowel),n) # 全てのデータからランダムに選択
x <- scale(Vowel[idx,2:10]) # 10の特徴量のうち量的なものを正規化して用いる
y <- Vowel$Class[idx] # 対応するラベル
# 樹形図を分割して表示する
hc <- hclust(dist(x,method="manhattan"),method="ward")
plot(hc,labels=y)
grp <- rect.hclust(hc,k=k,border="red")
# 分割した1つのグループ(この例では第7グループ)だけ再表示
dev.new()
sub <- hclust(dist(x[grp[[7]],],method="manhattan"),method="ward")
plot(sub,labels=y[grp[[7]]])
