library(kernlab)                 # ライブラリ kernlab 
x <- as.matrix(iris[,1:4])       # データを行列の変換
gamma <- median(dist(x))         # データ間の距離の中央値
sigma <- 1/(2*gamma^2)           # ガウスカーネルのパラメータ sigma
# ガウスカーネルを用いたカーネル主成分分析
kp <- kpca(x,kernel="rbfdot",kpar=list(sigma=sigma))  
plot(data.frame(pcv(kp))[,1:3])  # 第3主成分までプロット
