library(mlbench)
data(Vehicle)  ## 学習データ
input <- 1:18; output <- 19
n <- 500;
# k-近傍法に対する交互検証法で最適な k
k <- knn_est_k(Vehicle[,-19],Vehicle[,19],1:30)$k
km <- 30
eps <- 1
err <- c()
for(i in 1:10){
  idx <- sample(1:nrow(Vehicle),n)
  x <- as.matrix(Vehicle[idx,-19]); y <- Vehicle[idx,19]
  xtest <- as.matrix(Vehicle[-idx,-19]); ytest <- Vehicle[-idx,19]
  knn_pred <- knn(x, xtest, y, k=k)   # k-近傍法
  aknn_pred <- aknn(x, xtest, y, k=k, km=km, epsilon=eps)  # 適応的 k-近傍法
  err <- rbind(err,c(mean(knn_pred!=ytest),mean(aknn_pred!=ytest)))
}
# 予測誤差のボックスプロット
par(ps=16)
boxplot(err[,1],err[,2],names=c("k-nn","aknn"),main="data: Vehicle",ylab="prediction error")
