library(mlbench)
library(class)

# 学習データ
sigma <- 0.15; n <-500
p <- mlbench.spirals(n,sd=sigma); x <- p$x; y <- p$classes
# テストデータ
ptest <- mlbench.spirals(2000,sd=sigma)
xtest <- ptest$x; ytest <- ptest$classes

# 適応的 k-近傍法の設定
k <- 15; km <- 50; eps <- 1
aknn_pred <- aknn(x, xtest, y, k=k, km=km, epsilon=eps)  # 予測
knn_pred <- knn(x, xtest, y, k=k)                        # k-近傍法で予測
mean(aknn_pred!=ytest)   # 適応的 k-近傍法の予測誤差
mean(knn_pred!=ytest)    # k-近傍法の予測誤差
