library(class)      # knn
library(mlbench)    # mlbench.corners
dim <- 2
n <- 300
# 学習データの生成
p <- mlbench.corners(n,d=dim,sd=0.25)  
x <- p$x; y <- p$classes
# テスト点の生成
x1 <- seq(min(x[,1]),max(x[,1]),length=100)
x2 <- seq(min(x[,2]),max(x[,2]),length=100)
xtest <- expand.grid(x1,x2)  

k <- 1                             # k の値を設定
kn <- knn(x,xtest,y,k=k)           # k-近傍法を実行
# 学習データと判別境界をプロット
ypred <- matrix(match(kn,levels(factor(kn))),100,100)

par(ps=22,mai = c(0.85, 1, 0.68, 0.35))
plot(x,lwd=2,cex=1.2,xlab="x1",ylab="x2",
     main=paste(k,"-Nearest Neighbor",sep=""),col=y,pch=as.real(y)+20)        
for(i in 1:max(ypred))
  contour(x1,x2,ypred==i,levels=0.5,lwd=2,drawlabels=FALSE,add=TRUE,col=1,lty=3)
