library(nnet) # nnetパッケージの読み込み
data(iris) # データirisの読み込み
names(iris)[-5] <- abbreviate(names(iris))[-5] # 特徴量の名前を短縮
head(iris) # iris データセット
set.seed(1)
index <- sample(nrow(iris),nrow(iris)*0.7) # 7割を訓練データとして使用
(res <- multinom(Species~.,iris[index,])) # ロジスティックモデルの訓練
yhat <- predict(res,iris,type="class") # ラベルの予測
mean(yhat[index] !=iris$Species[index]) # 訓練誤差
mean(yhat[-index] !=iris$Species[-index]) # 予測誤差
table(true=iris$Species,prediction=yhat) # 詳細な判別結果

# ロジスティック判別によるクラスラベル予測結果を用いたデータの散布図
plot(iris[,-5],col=as.numeric(yhat),pch=c(21,24,25)[c(yhat)])
res.prob <- predict(res,iris,type="probs")
dev.new()
# データの第1,第４変数の和に対して，各クラスの事後確率をプロット
plot(iris[,1]+iris[,4],res.prob[,1],xlab="Sepal.Length+Sepal.Width",ylab="p(1|x)")
dev.new()
plot(iris[,1]+iris[,4],res.prob[,2],xlab="Sepal.Length+Sepal.Width",ylab="p(2|x)")
dev.new()
plot(iris[,1]+iris[,4],res.prob[,3],xlab="Sepal.Length+Sepal.Width",ylab="p(3|x)")
