data(iris) # データセットirisの読み込み
# ラベルを2値に変換
iris$Species <- factor(c(rep("set+vir",50),rep("ver",50),rep("set+vir",50)),
                       levels=c("set+vir","ver"))
names(iris)[-5] <- abbreviate(names(iris))[-5] # 特徴量の名前を短縮
head(iris) # iris データセット
set.seed(1)
index <- sample(nrow(iris),nrow(iris)*0.7) # 訓練データのインデックスを作成
res0 <- glm(Species~.,iris[index,],family=binomial) # 線形なロジスティック回帰
res <- glm(Species~.*.,iris[index,],family=binomial) # 2次の項まで含めてロジスティック回帰
res$coefficients # 学習した係数
logLik(res) # 対数尤度
# ラベルの予測
yhat <- levels(iris$Species)[c(predict(res,iris,type="response")>0.5)+1]
mean(yhat[index] !=iris$Species[index]) # 訓練誤差
mean(yhat[-index] !=iris$Species[-index]) # 予測誤差
table(true=iris$Species,prediction=yhat) # 判別の詳細な結果

# 線形な項のみを用いた場合のクラス事後確率
plot(iris[,1]+iris[,4],predict(res0,iris,type="response"),
     ylim=range(0,1),pch=c(21,24)[c(iris[,5])],
     col=iris[,5],xlab="Sepal.Length+Sepal.Width",ylab="p(1|x)",)
# 2次の項を含めた場合のクラス事後確率
plot(iris[,1]+iris[,4],predict(res,iris,type="response"),
     ylim=range(0,1),pch=c(21,24)[c(iris[,5])],
     col=iris[,5],xlab="Sepal.Length+Sepal.Width",ylab="p(1|x)")
