data(iris) # データセットirisの読み込み
# ラベルを2値に変換
iris$Species <- factor(c(rep("set+vir",50),rep("ver",50),rep("set+vir",50)),
                       levels=c("set+vir","ver"))
names(iris)[-5] <- abbreviate(names(iris))[-5] # 特徴量の名前を短縮
set.seed(1)
index <- sample(nrow(iris),nrow(iris)*0.7) # 訓練データのインデックスを作成
iris2 <- cbind(iris,new=sqrt(iris[,-5])) # データセットに特徴量の平方根を含める
head(iris2) # iris2の表示
res2 <- glm(Species~.,iris2[index,],family=binomial) # ロジスティック回帰
res2$coefficients # 各変数の係数
logLik(res2) # 対数尤度
yhat <- levels(iris2$Species)[(predict(res2,iris2,type="response")>0.5)+1]
mean(yhat[index] != iris2$Species[index]) # 訓練誤差
mean(yhat[-index] != iris2$Species[-index]) # 予測誤差
table(true=iris$Species,prediction=yhat) # 判別の詳細な内訳
