library(class) # for lvq
library(mlbench) # for mlbench.corners
dim <- 2 # 入力空間の次元
# 学習データの生成
n <- 300 # 学習データ数
smpl <- mlbench.corners(n,d=dim,sd=0.25)
x <- smpl$x
y <- smpl$classes
# 代表ベクトル(codebook)の初期化
size <- 8 # 代表ベクトルの数
k <- 1 # 初期化に使うk-NNの大きさ
cd <- lvqinit(x,y,size=size,k=k)
# 代表ベクトルの学習
cd3 <- lvq3(x,y,cd)
# 学習前後の判別境界のプロット
gsize <- 100 # グリッドのサイズ
x1 <- seq(min(x[,1]),max(x[,1]),length=gsize)
x2 <- seq(min(x[,2]),max(x[,2]),length=gsize)
xtest <- as.matrix(expand.grid(x1,x2))
yest <- lvqtest(cd,xtest)
yest3 <- lvqtest(cd3,xtest)
cntr <- matrix(match(yest,levels(factor(yest))),gsize,gsize)
cntr3 <- matrix(match(yest3,levels(factor(yest3))),gsize,gsize)
# 学習前の境界の表示
plot(x,col=y,pch=20+as.numeric(y),
	xlab="x1",ylab="x2",main="Initial Codebook")
points(cd$x,col=cd$cl,bg=cd$cl,pch=20+as.numeric(cd$cl),cex=2)
for(i in 1:max(cntr))
  contour(x1,x2,cntr==i,levels=0.5,lwd=2,lty=1,drawlabels=F,add=TRUE)
# 学習後の境界の表示
dev.new()
plot(x,col=y,pch=20+as.numeric(y),xlab="x1",ylab="x2",main="LVQ3")
points(cd3$x,col=cd3$cl,bg=cd$cl,pch=20+as.numeric(cd$cl),cex=2)
for(i in 1:max(cntr3))
  contour(x1,x2,cntr3==i,levels=0.5,lwd=2,lty=1,drawlabels=F,add=TRUE)
