library(class) # for lvq
library(mlbench) # for Vowel
data(Vowel)
# 学習データとテストデータの生成
n <- 600 # 学習データ数
idx <- sample(1:nrow(Vowel),n) # 学習データとテストデータをランダムに振り分ける
x <- Vowel[idx,2:10] # 10の特徴量のうち量的なものだけを考える
y <- Vowel$Class[idx] # 対応するラベル
xtest <- Vowel[-idx,2:10] # テスト用
ytest <- Vowel$Class[-idx]
# 代表ベクトル(codebook)の初期化
size <- 110 # 代表ベクトルの数 (1ラベルあたり10個を想定する)
cd <- lvqinit(x,y,size=size)
# 代表ベクトルの学習
cd3 <- lvq3(x,y,cd) # LVQ3
cd0 <- olvq1(x,y,cd) # OLVQ1
# 他の学習アルゴリズムを用いる場合も同様にする
# cd1 <- lvq1(x,y,cd) # LVQ1
# cd2 <- lvq2(x,y,cd) # LVQ2.1
# 学習結果の比較
# LVQ3の正誤表と予測誤差
(tab.lvq3 <- table(true=ytest,est=lvqtest(cd3,xtest)))
sum(diag(tab.lvq3))/length(ytest)
# OLVQ1の正誤表と予測誤差
(tab.olvq <- table(true=ytest,est=lvqtest(cd0,xtest)))
sum(diag(tab.olvq))/length(ytest)
