benchmark_demo <- function(){
  #デモを実行する関数
  #必要なパッケージ:kernlab, mlbench
  #必要な関数:mpm, mpm.rbf, predict.mpm
  ## Linear kernel
  cat("Linear kernel\n")
  mp <- mpm(x,y)   # ミニマックス確率マシンで学習
  mp_ypred <- predict(mp,xtest)
  print(paste("linear-mpm prediction err: ", mean(mp_ypred != ytest)))
  print(paste("worst-case err: ",mp$worst))
  sv <- ksvm(x,y,kernel="vanilladot") # サポートベクトルマシンで学習
  sv_ypred <- predict(sv,xtest)  
  print(paste("linear-svm prediction err: ",mean(sv_ypred != ytest))) 
  ## Gaussian kernel
  cat("Gaussian kernel\n")
  mp <- mpm.rbf(x,y)   # ミニマックス確率マシンで学習
  mp_ypred <- predict(mp,xtest)  
  print(paste("Gaussian kernel mpm prediction err: ", mean(mp_ypred != ytest))) 
  print(paste("worst-case err: ",mp$worst))  
  sv <- ksvm(x,y,kernel="rbfdot")  # サポートベクトルマシンで学習
  sv_ypred <- predict(sv,xtest)  
  print(paste("Gaussian kernel svm prediction err: ",mean(sv_ypred != ytest)))
}
# Sonar
cat("Data: Sonar\n")
data(Sonar); dat <- Sonar; n <- nrow(dat)
# 学習データ
subtrain <- sample(1:n,100)
x <- as.matrix(dat[subtrain,-ncol(dat)])
y <- dat[subtrain,ncol(dat)]
# テストデータ
xtest <- as.matrix(dat[-subtrain,-ncol(dat)])
ytest <- dat[-subtrain,ncol(dat)]
benchmark_demo()
# PimaIndiansDiabetes
cat("\nData: PimaIndiansDiabetes\n")
data(PimaIndiansDiabetes); dat <- PimaIndiansDiabetes; n <- nrow(dat)
# 学習データ
subtrain <- sample(1:n,400)
x <- as.matrix(dat[subtrain,-ncol(dat)])
y <- dat[subtrain,ncol(dat)]
# テストデータ
xtest <- as.matrix(dat[-subtrain,-ncol(dat)])
ytest <- dat[-subtrain,ncol(dat)] 
benchmark_demo()
