dat <- mlbench.spirals(400, cycles=1.2, sd=0.15) 
tdat <- mlbench.spirals(1000, cycles=1.2, sd=0.15)
x <- dat$x; y <- dat$classes           # 学習データ
xtest <- tdat$x; ytest <- tdat$classes # テストデータ

mp2 <- mpm.rbf(x,y)   # ミニマックス確率マシンで学習
mp_ypred <- predict(mp2,xtest)   # 予測
print(mean(mp_ypred != ytest))  # 予測誤り確率
print(mp2$worst)   # 最悪ケースでの予測誤り確率の推定値

sv <- ksvm(x,y,kernel="rbfdot")  # サポートベクトルマシンで学習
sv_ypred <- predict(sv,xtest)    # 予測
print(mean(sv_ypred != ytest))   # 予測誤り確率

par(ps=14,mfrow=c(1,2), mai = c(0.85, 1, 0.68, 0.35))
pch <- as.real(mp_ypred); pch[pch==1] <- 21; pch[pch==2] <- 24
plot(data.frame(xtest),col=mp_ypred,main="Min-Max Probability Machine",pch=pch)
pch <- as.real(sv_ypred); pch[pch==1] <- 21; pch[pch==2] <- 24
plot(data.frame(xtest),col=sv_ypred,main="Support Vector Machine",pch=pch)

