library(mlbench) 
library(kernlab)
dat <-  mlbench.2dnormals(400, cl=2) # 学習データ
x <- dat$x; y <- dat$classes  
tdat <-  mlbench.2dnormals(1000, cl=2) # テストデータ
xtest <- tdat$x; ytest <- tdat$classes
mp <- mpm(x,y)   # ミニマックス確率マシンで学習
ypred <- predict(mp,xtest)  # 予測
mean(ypred != ytest)   # 予測誤り確率
mp$worst # 最悪ケースでの予測誤り確率の推定値
sv <- ksvm(x,y,kernel="vanilladot")  # 線形サポートベクトルマシンで学習
ypred <- predict(sv,xtest)  # 予測
mean(ypred != ytest) # 線形サポートベクトルマシンの予測誤り確率
