library(klaR)
N <- 50
train.index <- sample(nrow(iris),N)

res.rda <- rda(Species~.,iris,subset=train.index)
cat("Training error of rda is",
    mean(predict(res.rda,iris[train.index,])$class !=
         iris[train.index,5]),"\n")
cat("Test error of rda is",
    mean(predict(res.rda,iris[-train.index,])$class !=
         iris[-train.index,5]),"\n")

M <- 10
err.tra <- rep(1,M)
err.gen <- rep(1,M)
param <- seq(0,1,length=M)
for(i in 1:M){
  res2.rda <- rda(Species~.,iris,subset=train.index,
                  lambda=param[i],gamma=0.5)
  err.tra[i] <- mean(predict(res2.rda,iris[train.index,])$class !=
                     iris[train.index,5])
  err.gen[i] <- mean(predict(res2.rda,iris[-train.index,])$class !=
                     iris[-train.index,5])
}
plot(param,err.tra,xlab="lambda",ylab="error rate",
     ylim=range(err.tra,err.gen))
points(param,err.gen,col=2,pch=2)

