library(svmpath)   # svmpath
library(mlbench)   # mlbench.spirals
dat <-    mlbench.2dnormals(200,  2, sd=1.2) ## 学習データ
x <- dat$x; y <- sign(as.real(dat$classes)-1.5)
kcv <- 5  ## k-交差検証法
C.list <- exp(seq(log(0.1),log(1000),l=100)) ## 正則化パラメータ C の候補
# ガウシアン・カーネルのパラメータの候補
sigma.list <- 1/quantile(dist(x),prob=seq(0.01,0.5,l=20))^2
idx <- sample(kcv,length(y),replace=TRUE)  ## k-交差検証法のグループ分け
cverr <- c()  ## 交差検証法による誤り確率の推定値
for (sigma in sigma.list){ print(sigma)
  err <- c()
  for (j in 1:kcv){
    ## k-交差検証法
    tmpx <- x[idx!=j,]; tmpy <- y[idx!=j]
    fit <- svmpath(tmpx,tmpy,kernel.function=radial.kernel,param.kernel=sigma)
    pred <- predict(fit,x[idx==j,],1/C.list,type="class")
    err <- rbind(err, colMeans(pred != y[idx==j]))
  }
  cverr <- rbind(cverr,colMeans(err))
}
p <- cbind(1:nrow(cverr),max.col(-cverr))
op <- p[which.min(cverr[p]),]
(opt.sigma <- sigma.list[op[1]]) ## 最適な sigma 
(opt.C <- C.list[op[2]])         ## 最適な C



