library(svmpath)   # svmpath を使う
library(kernlab)   # sigest を使う
library(mlbench)   # mlbench.2dnormals を使う
dat <-  mlbench.2dnormals(200,  2, sd=1)
x <- dat$x; y <- sign(as.real(dat$classes)-1.5)
sigma <-sigest(x)[2]  # ガウシアン・カーネルのパラメータの推定
fit <- svmpath(x,y,kernel.function=radial.kernel,param.kernel=sigma)
fit
par(ps=20,mai=c(1.,1.,0.7,0.7))
idx<-rev(order(colSums(abs((apply(fit$alpha,1,diff))))))[1:5]
plot(1/fit$lambda, fit$alpha[idx[1],],log='x',type="l",lwd=2,xlab="C",ylab="alpha")  
for (i in 2:length(idx))                   # alpha のパスのプロット
  lines(1/fit$lambda, fit$alpha[idx[i],],col=i,lwd=2,lty=i)
