library(kernlab)
library(mlbench)
# G=20 の多値判別
train <- mlbench.2dnormals(500,cl=20,sd=0.5)    # 学習データ
test  <- mlbench.2dnormals(1000,cl=20,sd=0.5)   # テストデータ
system.time(sv <- ksvm(train$x,train$classes))
system.time(sp <- ksvm(train$x,train$classes,type="spoc-svc"))
mean(predict(sv,test$x) != test$class)  # 2値の組み合わせによる予測誤差
mean(predict(sp,test$x) != test$class)  # spoc-svc の予測誤差
