library(kernlab)
x1 <- rbind(matrix(rnorm(150*2),150,2))   # データ
x2 <- rbind(matrix(rnorm(5*2),5,2))+3     # 外れ値
x <- rbind(x1,x2); y <- c(rep(1,150),rep(2,5))
# 確率密度の値を計算
p <- 150/155 * apply(dnorm(x),1,prod) + 5/155 * apply(dnorm(x,mean=3),1,prod)
K <- kernelMatrix(rbfdot(sigma=1),x)             # ガウシアン・カーネルで変換
dk <- sqrt(rowSums(K^2))                         # 変換されたデータのノルム
# プロット
par(mfcol=c(1,2),mai=c(1.6,1.3,0.7,0.7),ps=14,lwd=3,cex=1.5)
plot(data.frame(x),col=y,xlim=range(x[,1]),ylim=range(x[,2]))
plot(p,dk,xlab="probability density: p(x)",ylab="norm of k(,x)",col=y)
