library(kernlab)
library(mlbench)
x1 <- rbind(matrix(rnorm(150*2),150,2))   # データ
x2 <- rbind(matrix(rnorm(5*2),5,2))+3     # 外れ値
x <- rbind(x1,x2); y <- c(rep(1,150),rep(2,5))
sigma <- 1/(2*median(dist(x))^2)  # sigma をデータの距離行列から決める
sv <- ksvm(x,type='one-svc',nu=0.1,kpar=list(sigma=sigma))
mean(predict(sv)==FALSE)   # 外れ値とみなされる学習データの割合
plot(data.frame(x),col=(!predict(sv))+1,cex=1.5,lwd=3)
