library(kernlab)   # ksvm 
library(mlbench)   # mlbench.spirals
dat <- mlbench.spirals(400, cycles=1.2, sd=0.07) # 400 個の学習データを生成
x <- dat$x       # 入力データ
y <- dat$classes # ラベル
linsvm <- ksvm(x,y,type="C-svc",kernel="vanilladot")   # 線形カーネルを使う 
rbfsvm <- ksvm(x,y,type="C-svc",kernel="rbfdot") # ガウシアンカーネルを使う
par(mfcol=c(1,2),ps=16,lwd=2)
plot(x,col=predict(linsvm,x),main="Linear kernel")   # 線形カーネル
plot(x,col=predict(rbfsvm,x),main="Gaussian kernel") # ガウシアンカーネル
# テストデータ
testx <- matrix(rnorm(100),,2)
predict(rbfsvm,testx)  # テストデータに対する予測の結果
