library(kernlab)
library(mlbench)
rbf1 <- function(x,y)
   # ユーザが定義するカーネル関数
   # 入力(x:カーネル関数の第１引数,y:第２引数)
   # 出力:実数値
   (x%*%y) * exp(-sum(x^2)) * exp(-sum(y^2))
class(rbf1) <- "kernel"      # クラス属性を設定
dat <- mlbench.2dnormals(400, cl=2, r=sqrt(20), sd=2) # データの生成
x <- dat$x; y <- dat$classes
rbf1svm <- ksvm(x,y,type="C-svc",kernel=rbf1) # 定義した関数 rbf1 で学習
plot(rbf1svm,data=x) # 学習データと判別境界のプロット
