library(rpart)
library(mlbench)
data(Glass)
set.seed(1)
tra.index <- sample(nrow(Glass),(nrow(Glass)*0.7)%/% 1)
PRIOR <- rep(1/6,6)
res <- rpart(Type~.,Glass[tra.index,],method="class")
pred <- predict(res,Glass,type="class")
res2 <- rpart(Type~.,Glass[tra.index,],method="class",parms=list(prior=PRIOR))
pred2 <- predict(res2,Glass,type="class")

pred[tra.index]
cat("Training error is ")
cat(mean(pred[tra.index]!=Glass$Type[tra.index]))
cat("\n")
cat("Test error is ")
cat(mean(pred[-tra.index]!=Glass$Type[-tra.index]))
cat("\n")
cat("Training error of tree with uniform prior is ")
cat(mean(pred2[tra.index]!=Glass$Type[tra.index]))
cat("\n")
cat("Test error of tree with uniform prior is ")
cat(mean(pred2[-tra.index]!=Glass$Type[-tra.index]))
cat("\n")

L <- levels(Glass$Type)
E.tra <- matrix(0,length(L),length(L))
E.gen <- matrix(0,length(L),length(L))
E2.tra <- matrix(0,length(L),length(L))
E2.gen <- matrix(0,length(L),length(L))

for(i in 1:length(L)){
  for(j in 1:length(L)){
    E.tra[i,j] <- mean(pred[tra.index][Glass$Type[tra.index]==L[i]]==L[j])
    E.gen[i,j] <- mean(pred[-tra.index][Glass$Type[-tra.index]==L[i]]==L[j])
    E2.tra[i,j] <- mean(pred2[tra.index][Glass$Type[tra.index]==L[i]]==L[j])
    E2.gen[i,j] <- mean(pred2[-tra.index][Glass$Type[-tra.index]==L[i]]==L[j])
  }
}
cat("(i,j) component represents p(prediction=j|true label=i) for test data.\n")
print(E.gen)
cat("(i,j) component represents p(prediction=j|true label=i) for test data.\n")
print(E2.gen)
par(mfcol=c(1,2))
plot(res)
text(res)
plot(res2)
text(res2)
