library(rpart) # パッケージrpartの読み込み
library(mlbench) # パッケージmlbenchの読み込み
data(Glass) # Glassデータセットの読み込み
set.seed(1)
# 訓練に用いるデータのインデックスを抽出
tra.index <- sample(nrow(Glass),nrow(Glass)*0.7)
# ジニ係数で学習
res <- rpart(Type~.,Glass[tra.index,],method="class",parms=list(split="gini"))
pred <- predict(res,Glass,type="class") # ラベルの予測
mean(pred[tra.index]!=Glass$Type[tra.index]) # 訓練誤差
mean(pred[-tra.index]!=Glass$Type[-tra.index]) # 予測誤差
# エントロピーで学習
res2 <- rpart(Type~.,Glass[tra.index,],method="class",
              parms=list(split="information"))
pred2 <- predict(res2,Glass,type="class") # ラベルの予測

mean(pred2[tra.index]!=Glass$Type[tra.index]) # 訓練誤差
mean(pred2[-tra.index]!=Glass$Type[-tra.index]) #　予測誤差

# ジニ係数で学習した決定木
plot(res);text(res)
dev.new()
# エントロピーで学習した決定木
plot(res2);text(res2)
