library(rpart) # パッケージrpartの読み込み
library(mlbench) # パッケージmlbenchの読み込み
data(Glass) # Glassデータセットの読み込み
T <- 50
err.tra <- rep(0,T)
err.gen <- rep(0,T)
res <- list()
# 訓練に用いるデータセットを変えながら決定木を学習
for(i in 1:T){
  tra.index <- sample(nrow(Glass),nrow(Glass)*0.7)
  res[[i]] <- rpart(Type~.,Glass[tra.index,],method="class")
  yhat <- predict(res[[i]],Glass,type="class")
  err.tra[i] <- mean(yhat[tra.index]!=Glass$Type[tra.index])
  err.gen[i] <- mean(yhat[-tra.index]!=Glass$Type[-tra.index])
}
# 訓練誤差，予測誤差のボックスプロット
boxplot(data.frame(cbind(err.tra,err.gen)),
        names=c("Training error","Test error"))

plot(res[[which.max(err.tra)]]) # 訓練誤差が最大となる決定木
text(res[[which.max(err.tra)]])
dev.new()
plot(res[[which.min(err.tra)]]) # 訓練誤差が最小となる決定木
text(res[[which.min(err.tra)]])
